(*
  Converts bitmap to *.256 SWOS picture format
*)

program BMP_to_SWOS;

uses bmp,def,dos,misc;

var raw_data: pscreen;
    pal_ptr: ppalette;
    param_num: word;
    dummy, bmpresult: word;
    src_name: string;
    dest_name: string;
    dest_file: file;
    D: DirStr;
    N: NameStr;
    E: ExtStr;

begin
     param_num:=ParamCount;
     if param_num<>1 then
       begin
         writeln('Simple program for converting bitmaps to SWOS .256 screens');
         writeln('Usage: s2bmp swtitle.bmp');
         writeln;
         writeln('by Karakas Zlatko, 2001.');
         writeln;
         writeln('Have fun ;)');
         halt(1);
       end;
     src_name:=ParamStr(1);
     new(raw_data);
     new(pal_ptr);
     bmpresult:=LoadBMPScreen(src_name,raw_data,pal_ptr);
     if bmpresult <> ALL_OK then
       begin
         dispose(raw_data);
         dispose(pal_ptr);
         error(bmpresult);
       end;
     FSplit(src_name,D,N,E);
     dest_name:=D+N+'.256';
     assign(dest_file, dest_name);
     {$I-} rewrite(dest_file,1); {$I+}
     if IOResult = 0 then
     begin
       BlockWrite(dest_file,raw_data^,SizeOf(raw_data^),dummy);
       BlockWrite(dest_file,pal_ptr^,SizeOf(pal_ptr^),dummy);
     end else
     begin
       dispose(raw_data);
       dispose(pal_ptr);
       error(ERR_CANT_WRITE);
     end;
     close(dest_file);
     writeln(N+E,' -> ',N,'.256');
     dispose(raw_data);
     dispose(pal_ptr);
end.