(*
  Converts SWOS *.256 pictures into bitmaps
*)

program swos_to_bmp;

uses def,dos,bmp;

var src_file,dest_file: file;
    src_name,dest_name:string;
    param_num: word;
    raw_data: pscreen;
    temp: array [0..319] of byte;
    dummy,i: word;
    pal: palette;
    D: DirStr;
    N: NameStr;
    E: ExtStr;
    fh: TBMPFileHeader;
    ih: TBMPInfoHeader;
    bmppal: TBMPPalette;

begin
  param_num:=ParamCount;
  if param_num<>1 then
    begin
      writeln('Simple program for converting SWOS .256 screens to bitmaps');
      writeln('Usage: s2bmp swtitle.256');
      writeln;
      writeln('by Karakas Zlatko, 2001.');
      writeln;
      writeln('Have fun! ;)');
      halt(1);
    end;
  src_name:=ParamStr(1);
  new(raw_data);
  assign(src_file,src_name);
  {$I-} reset(src_file,1); {$I+}
  if IOResult = 0 then
  begin
    BlockRead(src_file,raw_data^,SizeOf(raw_data^),dummy);
    BlockRead(src_file,pal,SizeOf(pal),dummy);
  end else
  begin
    dispose(raw_data);
    writeln('Error: File not found');
    halt(1);
  end;
  close(src_file);
  for i:=99 downto 0 do
    begin
      move(raw_data^[i],temp,320);
      move(raw_data^[199-i],raw_data^[i],320);
      move(temp,raw_data^[199-i],320);
    end;

  { ---***--- }
  for i:=0 to 255 do
    begin
      bmppal[i].cl_Red := pal[i,1] * 4;
      bmppal[i].cl_Green := pal[i,2] * 4;
      bmppal[i].cl_Blue := pal[i,3] * 4;
    end;
  FSplit(src_name,D,N,E);
  dest_name:=D+N+'.bmp';
  assign(dest_file,dest_name);
  {$I-} rewrite(dest_file,1); {$I+}
  if IOResult = 0 then
    begin
      fh.ID:=$4D42;
      fh.FSize:=54+SizeOf(pal)+SizeOf(raw_data^);
      fh.Reserved1:=0;
      fh.Reserved2:=0;
      fh.BOfsbits:=54+4*256;
      ih.InfoSize:=40;
      ih.Width:=320;
      ih.Height:=200;
      ih.Planes:=1;
      ih.BitsPerPixel:=8;
      ih.Compression:=0;
      ih.ImageSize:=SizeOf(raw_data^);
      ih.XPixPerMeter:=0;
      ih.YPixPerMeter:=0;
      ih.ColorUsed:=256;
      ih.ColorImportant:=0;
      BlockWrite(dest_file,fh,SizeOf(fh)+SizeOf(ih)+SizeOf(bmppal),dummy);
      BlockWrite(dest_file,raw_data^,SizeOf(raw_data^),dummy);
    end
  else
    begin
      dispose(raw_data);
      writeln('Error: Could not write file');
      halt(1);
    end;
  close(dest_file);
  writeln(N+E,' -> ',N+'.bmp');
  dispose(raw_data);
end.