(*
  Program for viewing *.256 SWOS pictures
*)

program swos_viewer;

{$DEFINE RELEASE}

uses gfx, def;

var param_num: word;
    dummy: word;
    file_name: string;
    bitmap: pscreen;
    pal: palette;
    srcfile: file;

procedure local_error(errstr:string);
begin
     writeln('Error: ',errstr);
     halt(1);
end;

procedure WaitForKey; assembler;
asm
  mov  ah, 00h
  int  16h
end;

procedure WaitRetrace; assembler;
asm
  mov dx,3DAh
@@l1:
  in al,dx
  and al,08h
  jnz @@l1
@@l2:
  in al,dx
  and al,08h
  jz  @@l2
end;

begin
     param_num:=ParamCount;
     if param_num<>1 then
       begin
         writeln('Simple program for viewing SWOS .256 screens');
         writeln('Usage: sview swtitle.256');
         writeln;
         writeln('by Karakas Zlatko, 2001');
         writeln;
         writeln('Have fun ;)');
         halt(1);
       end;
     file_name:=ParamStr(1);
     assign(srcfile, file_name);
     {$I-} reset (srcfile,1); {$I+}
     if IOresult <> 0 then
       begin
         writeln('Error: File not found');
         halt(1);
       end;
     if FileSize(srcfile)<>64768 then
       begin
         Close(srcfile);
         local_error('Not a SWOS type picture');
       end
     else
       begin
          New(bitmap);
          BlockRead(srcfile, bitmap^, SizeOf(bitmap^), dummy);
          BlockRead(srcfile, pal, SizeOf(pal), dummy);
          SetMCGA;
          WaitRetrace;
          SetPalette(pal);
          Flip(bitmap,pvga);
          WaitForKey;
       end;
     SetText;
     Close(srcfile);
     Dispose(bitmap);
end.