{***************************************************************************}
{*                                                                         *}
{*                          GFX v2.0 - ASM mostly ;)                       *}
{*                                                                         *}
{***************************************************************************}

{$D+} {$G+} {$L+} {$N+}
{$Q-} {$R-} {$S-} {$T-}
{$V-} {$X+} {$Y+}

unit GFX;

interface

uses def,misc;

var i: word;
    lookup_table: table320;


{ Basic }
procedure SetMCGA;
procedure SetText;
procedure Cls (where: pointer; col: byte);
procedure Putpixel (where: pointer; x,y: word; col: byte);
function  GetPixel (where: pointer; x,y: word): byte;

{ Palette }
procedure GetPalette(var pal: palette);
procedure GetPPalette(pal: ppalette);
procedure SetPalette(pal: palette);
procedure SetPPalette(pal: ppalette);
procedure GetColor (ColorNo: byte; var r,g,b: byte);
procedure SetColor (ColorNo: byte; r,g,b: byte);
procedure BlackOut;
procedure FadeOut;
procedure FadeIn(pal: palette; wait_retrace:boolean);
procedure RotatePalette(var pal: palette);
procedure PaletteGradient(var pal: palette; col:byte);
function  LoadPalette(file_name:string; var pal: palette): word;

{ Image processing }

procedure Pixelate(sourceptr,destptr:pscreen;n:word);
procedure Wave2D (sourceptr,destptr:pscreen;pomdeg,deg:real;n:word);

{ Virtual Screen }
procedure VirScrInit (var p: pointer; var pseg: word);
procedure VirScrDone (p: pointer);
procedure Flip (source, dest: pointer);
procedure FlipBox (p1: pointer; var p2: pointer; x1,y1,duz,vis,x2,y2: word);

implementation

{}

procedure SetMCGA; assembler;
asm
  mov  ax,13h
  int  10h
end;


{}

procedure SetText; assembler;
asm
  mov  ax,03h
  int  10h
end;


{}

procedure Cls (where: pointer; col: byte); assembler;
asm
  db   66h, 33h, 0ffh {xor edi, edi}
  mov  al, col
  mov  cx, 16000
  mov  es, [bp+10]
  mov  di, [bp+8]
  mov  ah, al
  mov  bx, ax
  db   66h, 0C1h, 0E0h, 16h { shl eax, 16 }
  mov  ax, bx
  {db   66h, 69h, 0c0h, 00h, 00h, 00h, 00h {imul eax, 01010101h}
  db   0f3h, 66h, 0abh {rep stosd}
end;


{}

procedure PutPixel (where: pointer; x,y: word; col: byte); assembler;
asm
  mov  bx, [bp+12]
  mov  es, [bp+14]
  mov  ax, y
  mov  di, ax
  ror  ax, 8
  shl  di, 6
  add  di, ax
  add  di, x
  add  di, bx
  mov  al, col
  mov  [es:di],al
  (*mov  dx, x
  mov  di, y
  mov  al, col
  mov  es, where
  mov  bx, offset lookup_table
  add  di, di
  mov  si, [bx+di]
  add  si, dx
  mov  [es:si], al*) {inace, ovo radi, samo nema klipovanja}
end;


{}

function GetPixel (where: pointer; x,y: word): byte; assembler;
asm
   mov  es, [bp+12]
   mov  bx, [bp+10]
   mov  ax, y
   mov  si, ax
   ror  ax, 8
   shl  si, 6
   add  si, ax
   add  si, x
   add  si, bx
   mov  al, [es:si]
end;



{}

{ prebacuje paletu iz graficke u niz pal }
procedure GetPalette (var pal: palette); assembler;
asm
  cli
  les  di, pal
  mov  dx, 3c7h
  xor  ax, ax
  out  dx, al
  mov  dx, 3c9h
  mov  cx, 768
  rep  insb
  sti
end;

{}

procedure GetPPalette(pal: ppalette); assembler;
asm
  cli
  mov  es, [bp+8]
  mov  di, [bp+6]
  mov  dx, 3c7h
  xor  ax, ax
  out  dx, al
  mov  dx, 3c9h
  mov  cx, 768
  rep  insb
  sti
end;

{}

{ prebacuje paletu zadatu kao parametar u graficku }
procedure SetPalette(pal: palette); assembler;
asm
  cli
  mov  bx, ds
  lds  si, pal
  mov  dx, 3c8h
  xor  al, al
  out  dx, al
  inc  dx
  mov  cx, 768
  rep  outsb
  mov  ds, bx
  sti
end;


{}

procedure SetPPalette(pal: ppalette); assembler;
asm
  cli
  mov  bx, ds
  mov  ds, [bp+8]
  mov  si, [bp+6]
  mov  dx, 3c8h
  xor  ax, ax
  out  dx, al
  inc  dx
  mov  cx, 768
  rep  outsb
  mov  ds, bx
  sti
end;

{}

{ procedura cita RGB vrednosti odredjene boje }
Procedure GetColor(ColorNo : Byte; Var R,G,B : Byte); assembler;
asm
  cli
  mov  dx, 3c7h
  mov  al, ColorNo
  out  dx, al
  mov  dx, 3c9h
  les  di, R
  in   al, dx
  mov  [es:di],al
  inc  di
  in   al, dx
  mov  [es:di],al
  inc  di
  in   al, dx
  mov  [es:di],al
  sti
end;


{}

{ namesta RGB vrednosti odredjene boje }
procedure SetColor(ColorNo: Byte; R,G,B : Byte); assembler;
asm
  cli
  mov  dx, 3c8h    { broj porta za upis boje }
  mov  al, ColorNo { stavljam broj boje u al }
  out  dx, al      { upisujem boju u port }

  inc  dx          { port za vrednosti boje, 3c9h }

  mov  al, R
  out  dx, al
  mov  al, G
  out  dx, al
  mov  al, B
  out  dx, al      { pomeram vrednosti za boje u al, i pisem na port }
  {lea  ax, R
  mov  cx, 3
  rep  outsb}
  sti
end;


{}

{ Zacrni ekran tako sto podesi sve boje na nulu }
Procedure Blackout; assembler;
asm
  cli
  mov dx, 3c8h
  xor al, al
  out dx, al
  inc dx

  mov cx, 256
 @L1:
  out dx, al
  out dx, al
  out dx, al
  dec cx
  jnz @L1
  sti
end;


{}

procedure FadeOut; assembler;
asm
  cli

  mov  cx, 64
@loop1:
  call waitretrace
  mov  bx, 255
@loop2:
  mov  dx, 3c7h
  mov  ax, bx
  out  dx, al
  mov  dx, 3c9h
  in   al, dx
  mov  si, ax
  in   al, dx
  mov  di, ax
  in   al, dx
@cmp1:
  test si, si
  jnz  @dec1
@cmp2:
  test di, di
  jnz  @dec2
@cmp3:
  test ax, ax
  jnz  @dec3
@setcol:
  dec  dx
  push ax
  mov  ax, bx
  out  dx, al
  inc  dx
  mov  ax, si
  out  dx, al
  mov  ax, di
  out  dx, al
  pop  ax
  out  dx, al

  dec  bx
  jnz  @loop2
  dec  cx
  jnz  @loop1

  sti
  ret

@dec1:
  dec  si
  jmp  @cmp2
@dec2:
  dec  di
  jmp  @cmp3
@dec3:
  dec  ax
  jmp  @setcol

end;


{}

{ FadeIn }
procedure FadeIn (pal: palette; wait_retrace: boolean); assembler;
asm
  cli

  mov  ax, [bp+6] {wait_retrace}
  test ax, ax
  jz   @no_retrace
  call waitretrace
@no_retrace:
  call blackout
  mov  ch, 64
  lds  bx, pal

  jmp  @go

@loop1:
  call waitretrace
@go:
  mov  di, 255

{ uzmi tri boje iz graficke }
@loop2:
  mov  dx, 3c7h
  mov  ax, di
  out  dx, al
  mov  dx, 3c9h
  in   al, dx
  mov  cl, al
  in   al, dx
  mov  ah, al
  in   al, dx

{ uporedi ih sa odgovarajucim iz pal-a }
  mov  si, di
  shl  si, 1
  add  si, di
@cmp1:
  cmp  cl, byte ptr [bx+si]
  jb   @inc1
@cmp2:
  inc  si
  cmp  ah, byte ptr [bx+si]
  jb   @inc2
@cmp3:
  inc  si
  cmp  al, byte ptr [bx+si]
  jb   @inc3

{ vrati (eventualno izmenjene) boje u graficku }
@setcol:
  push ax
  push ax
  dec  dx
  mov  ax, di
  out  dx, al
  inc  dx
  mov  al, cl
  out  dx, al
  pop  ax
  mov  al, ah
  out  dx, al
  pop  ax
  out  dx, al

  dec  di
  jnz  @loop2
  dec  ch
  jnz  @loop1

  sti
  mov  sp, bp
  pop  bp
  retf 6

{ ako su manje, povecaj ih }
@inc1:
  inc  cl
  jmp  @cmp2
@inc2:
  inc  ah
  jmp  @cmp3
@inc3:
  inc  al
  jmp  @setcol

end;


{}

procedure RotatePalette(var pal: palette); assembler;
asm
  std
  mov  cx, 381
  mov  si, di
  mov  ax, ds
  add  di, 767
  add  si, 763
  mov  es, ax
  mov  bx, [di]
  sub  di, 2
  mov  dx, [di]
  inc  di
  rep  movsw
  cld
  dec  di
  mov  [di], dx
  add  di, 2
  mov  [di], bl
end;


{}

function LoadPalette (file_name:string; var pal: palette): word;
var file_src: file;
    dummy: word;
begin
     LoadPalette:=ERR_UNKNOWN;
     assign(file_src, file_name);
     {$I-} reset(file_src,1); {$I+}
     if IOResult <> 0 then
       begin
         LoadPalette:=ERR_FILE_NOT_FOUND;
         exit;
       end;
     BlockRead(file_src, pal, SizeOf(pal), dummy);
     LoadPalette:=ALL_OK;
end;


{}

{ Ova procedura puni paletu nijansama odredjene boje; za sada su moguce
  samo crvena, zelena i plava, parametri su redom 1,2,3 }
Procedure PaletteGradient(var pal: palette; col: byte);
var i:integer;
begin
     If (col<1) or (col>3) then col:=1;
     FillChar(pal,SizeOf(pal),0);
     for i:=0 to 255 do pal[i,col]:= i mod 64;
end;


{}
{ Inicijalizacija virtualnog ekrana }
Procedure VirScrInit (var p: pointer; var pseg: word);
begin
  getmem (p,64000);
  pseg := seg (p^);
end;


{}

procedure Pixelate(sourceptr,destptr:pscreen;n:word);

var temp,ost,i,j: word;
begin
     if n=1 then begin flip(sourceptr, destptr); exit; end;
     if (n>200) or (n<2) then exit;
     temp:=200 div n;
     ost:=200 - n*temp;
     for i:=0 to temp-1 do
     begin
         for j:=0 to 319 do
             destptr^[i*n,j]:=sourceptr^[i*n,j-j mod n];
         for j:=0 to n-2 do
             move(destptr^[n*i,0],destptr^[n*i+j+1,0],320);
     end;
     if ost<>0 then
     begin
     for i:=0 to 319 do
         destptr^[temp*n,i]:=sourceptr^[temp*n,i-i mod n];
     for i:=0 to ost-1 do
         move(destptr^[temp*n,0],destptr^[temp*n+i+1,0],320);
     end;
end;


{}

procedure Wave2D (sourceptr,destptr:pscreen;pomdeg,deg:real;n:word);

var i,x:word;
    sin0, sind, tmp: real;
begin
{     sin0:=0;
     tmp:=sin(deg);
     sind:=tmp;}
     for i:=0 to 199 do
     begin
          deg:=deg+pomdeg;
          x:=round(n*((sin(deg)+1)));
          { ---***--- }
          x:=round(n*(sin(deg)));
          move(sourceptr^[i,0],destptr^[i,x],320-x);
     end;
end;


{}

{ Dealokacija memorije za virtualni ekran }
Procedure VirScrDone (p: pointer);
begin
  freemem (p,64000);
end;

{}

Procedure Flip (source, dest: pointer); assembler;
asm
  db 66h; xor  si, si
  db 66h; xor  di, di
  mov  dx, ds
  mov  ds, [bp+12]
  mov  es, [bp+8]
  mov  si, [bp+10]
  mov  di, [bp+6]
  mov  cx, 16000
  (*db   0f3h, 66h, 0a5h {rep movsd}*)
  db 66h; rep movsw
  mov  ds, dx
end;


{}
{ Prebaci box na ekran }
Procedure FlipBox (p1: pointer; var p2: pointer; x1,y1,duz,vis,x2,y2: word);
var
  i: byte;
  seg1,seg2,ofs1,ofs2: word;
begin
  seg1 := seg (p1^);
  seg2 := seg (p2^);
  ofs1 := ofs (p1^);
  ofs2 := ofs (p2^);
  for i := 0 to (vis-1) do
  move (mem[seg1:ofs1+x1+(y1+i)*320], mem[seg2:ofs2+x2+(y2+i)*320], duz);
end;

(*BEGIN
     for i:=0 to 319 do
     begin
       lookup_table[i]:=i*320;
     end;*)
END.